#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN WAS DEVELOPED AND TESTED UNDER WINDOWS VISTA ONLY AND MAY OR MAY NOT WORK ON A MAC. 
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
# -----------------------------------------------------------------------------------------------
#    Name:	Connect Guide Points
#      By:	sdmitch
#   Usage:	Connect guide points defining a profile of an object.
#			Note:	Profiles must be selected one at a time.
#			
#    Date:	Jun 2012
#------------------------------------------------------------------------------------------------
#
require 'Sketchup'
#
if not file_loaded?(File.basename(__FILE__))
    UI.menu('Plugins').add_item('Connect GPs') { Connect_Guide_Points.main }
		file_loaded(File.basename(__FILE__))
end
#
module Connect_Guide_Points
	def self.main
		mod = Sketchup.active_model
		ent = mod.active_entities
		sel = mod.selection
		unless sel.empty?
			cpts=sel.select{|cp| cp.is_a? Sketchup::ConstructionPoint}
			unless cpts.empty?
				bb=Geom::BoundingBox.new
				cpts.each{|p| bb.add p.position}; 
				pt = bb.min; pts=[]
				while cpts.length>1
					hash={};cpts.each{|p| hash[p]=pt.distance(p.position)};
					csrt = hash.sort{ |a,b| a[1] <=> b[1] }.map { |n| n[0] }
					pts<<csrt[0];pt=csrt[0].position;cpts.delete(csrt[0])
				end
				pts<<cpts[0]
				unless pts.length < 2
					mod.start_operation "Connect GPs"
					mod.layers.add "Profiles"; mod.active_layer = "Profiles"
					grp=ent.add_group;gent=grp.entities
					for i in 1...pts.length
						gent.add_line(pts[i-1].position,pts[i].position)
					end
					gent.add_line(pts[-1].position,pts[0].position) if UI.messagebox("Close the loop?",MB_YESNO)==6
					mod.active_layer = "Layer0"
					mod.commit_operation
				else
					UI.messagebox "Less than 2 Guide Points in the selection"
				end
				sel.clear
			else
				UI.messagebox "No Guide Points in Selection"
			end
		else
			UI.messagebox  "Nothing Selected"
		end
	end
end
